Freeciv-3.1: /fast/freeciv/nightly/S3_1/server/techtools.c File Reference

Freeciv-3.1

Loading...
Searching...
No Matches
Functions
techtools.c File Reference
`#include "astring.h"`
`#include "fcintl.h"`
`#include "log.h"`
`#include "mem.h"`
`#include "rand.h"`
`#include "shared.h"`
`#include "support.h"`
`#include "game.h"`
`#include "government.h"`
`#include "movement.h"`
`#include "player.h"`
`#include "research.h"`
`#include "tech.h"`
`#include "unit.h"`
`#include "luascript_types.h"`
`#include "citytools.h"`
`#include "cityturn.h"`
`#include "connecthand.h"`
`#include "gamehand.h"`
`#include "maphand.h"`
`#include "notify.h"`
`#include "plrhand.h"`
`#include "unittools.h"`
`#include "script_server.h"`
`#include "techtools.h"`

Go to the source code of this file.

## Functions

static Tech_type_id | pick_random_tech_to_lose (const struct research *presearch)
static Tech_type_id | pick_random_tech (const struct research *presearch)
static Tech_type_id | pick_cheapest_tech (const struct research *presearch)
static void | research_tech_lost (struct research *presearch, Tech_type_id tech)
static void | forget_tech_transferred (struct player *pplayer, Tech_type_id tech)
void | research_apply_penalty (struct research *presearch, Tech_type_id tech, int penalty_percent)
void | script_tech_learned (struct research *presearch, struct player *originating_plr, struct advance *tech, const char *reason)
static void | tech_researched (struct research *research)
void | do_tech_parasite_effect (struct player *pplayer)
static void | package_research_info (struct packet_research_info *packet, const struct research *presearch)
void | send_research_info (const struct research *presearch, const struct conn_list *dest)
void | found_new_tech (struct research *presearch, Tech_type_id tech_found, bool was_discovery, bool saving_bulbs)
static bool | lose_tech (struct research *research)
void | update_bulbs (struct player *pplayer, int bulbs, bool check_tech)
static struct government * | pick_random_government (struct player *pplayer)
void | choose_random_tech (struct research *research)
void | choose_tech (struct research *research, Tech_type_id tech)
void | choose_tech_goal (struct research *presearch, Tech_type_id tech)
void | init_tech (struct research *research, bool update)
void | give_initial_techs (struct research *presearch, int num_random_techs)
Tech_type_id | steal_a_tech (struct player *pplayer, struct player *victim, Tech_type_id preferred)
void | handle_player_research (struct player *pplayer, int tech)
void | handle_player_tech_goal (struct player *pplayer, int tech_goal)
Tech_type_id | pick_free_tech (struct research *presearch)
void | give_immediate_free_tech (struct research *presearch, Tech_type_id tech)
bool | tech_transfer (struct player *plr_recv, struct player *plr_donor, Tech_type_id tech)

## Function Documentation

## ◆ choose_random_tech()

void choose_random_tech | ( | struct research * | research | ) |

Finds and chooses (sets) a random research target from among all those available until presearch->researching != A_UNSET. Players may research more than one tech in this function. Possible reasons:

- techpenalty < 100;
- research.got_tech = TRUE and enough bulbs was saved;
- research.researching = A_UNSET and enough bulbs was saved.

Definition at line 967 of file techtools.c.

Referenced by end_phase(), and init_tech().

## ◆ choose_tech()

void choose_tech | ( | struct research * | research,
|  | Tech_type_id | tech
| ) |  |

Called when a player chooses the tech they want to research (or when the server chooses it for them automatically).

This takes care of all side effects so the research target probably shouldn't be changed outside of this function (doing so has been the cause of several bugs).

Definition at line 982 of file techtools.c.

Referenced by choose_random_tech(), dai_manage_tech(), end_phase(), found_new_tech(), handle_player_research(), and init_tech().

## ◆ choose_tech_goal()

void choose_tech_goal | ( | struct research * | presearch,
|  | Tech_type_id | tech
| ) |  |

Called when a player chooses the tech goal they want to research (or when the server chooses it for them automatically).

Definition at line 1050 of file techtools.c.

Referenced by dai_manage_tech(), and handle_player_tech_goal().

## ◆ do_tech_parasite_effect()

void do_tech_parasite_effect | ( | struct player * | pplayer | ) |

Give technologies to players with EFT_TECH_PARASITE (traditionally from the Great Library).

Definition at line 143 of file techtools.c.

Referenced by end_phase().

## ◆ forget_tech_transferred()

static void forget_tech_transferred | ( | struct player * | pplayer,
|  | Tech_type_id | tech
| ) |  |

static

Let the player forget one tech.

Definition at line 1388 of file techtools.c.

Referenced by tech_transfer().

## ◆ found_new_tech()

void found_new_tech | ( | struct research * | presearch,
|  | Tech_type_id | tech_found,
|  | bool | was_discovery,
|  | bool | saving_bulbs
| ) |  |

Players sharing the research have got a new technology (from somewhere). 'was_discovery' is passed on to upgrade_city_extras. Logging and notification is not done here as it depends on how the tech came.

Definition at line 327 of file techtools.c.

Referenced by api_edit_give_technology(), do_tech_parasite_effect(), give_immediate_free_tech(), give_initial_techs(), handle_diplomacy_accept_treaty_req(), steal_a_tech(), and tech_researched().

## ◆ give_immediate_free_tech()

void give_immediate_free_tech | ( | struct research * | presearch,
|  | Tech_type_id | tech
| ) |  |

Give an immediate free tech (probably chosen with pick_free_tech()). Applies freecost.

Definition at line 1379 of file techtools.c.

Referenced by city_build_building(), and found_new_tech().

## ◆ give_initial_techs()

void give_initial_techs | ( | struct research * | presearch,
|  | int | num_random_techs
| ) |  |

Gives global (read from the game.ruleset file) and nation (read from the nation ruleset files) initial techs as specified in the ruleset, and random free technologies thanks to the techlevel setting.

Definition at line 1161 of file techtools.c.

Referenced by create_animals(), create_barbarian_player(), create_command_newcomer(), handle_edit_player_create(), and srv_ready().

## ◆ handle_player_research()

void handle_player_research | ( | struct player * | pplayer,
|  | int | tech
| ) |  |

Handle incoming research packet. Need to check correctness Set the player to be researching the given tech.

If there are enough accumulated research points, the tech may be acquired immediately.

Definition at line 1311 of file techtools.c.

Referenced by server_handle_packet().

## ◆ handle_player_tech_goal()

void handle_player_tech_goal | ( | struct player * | pplayer,
|  | int | tech_goal
| ) |  |

Handle incoming player_tech_goal packet Called from the network or AI code to set the player's tech goal.

Definition at line 1334 of file techtools.c.

Referenced by server_handle_packet().

## ◆ init_tech()

void init_tech | ( | struct research * | research,
|  | bool | update
| ) |  |

Initializes tech data for the research.

Definition at line 1069 of file techtools.c.

Referenced by create_animals(), create_barbarian_player(), create_command_newcomer(), handle_edit_player_create(), sg_load_researches(), sg_load_researches(), and srv_ready().

## ◆ lose_tech()

static bool lose_tech | ( | struct research * | research | ) |

static

Is player about to lose tech?

Definition at line 607 of file techtools.c.

Referenced by update_bulbs().

## ◆ package_research_info()

static void package_research_info | ( | struct packet_research_info * | packet,
|  | const struct research * | presearch
| ) |  |

inlinestatic

Fill packet fields. Helper for following functions.

Definition at line 238 of file techtools.c.

Referenced by send_research_info().

## ◆ pick_cheapest_tech()

static Tech_type_id pick_cheapest_tech | ( | const struct research * | presearch | ) |

static

Returns cheapest researchable tech, random among equal cost ones.

Definition at line 935 of file techtools.c.

Referenced by pick_free_tech().

## ◆ pick_free_tech()

Tech_type_id pick_free_tech | ( | struct research * | presearch | ) |

Choose a free tech.

Definition at line 1360 of file techtools.c.

Referenced by api_edit_give_technology(), city_build_building(), and found_new_tech().

## ◆ pick_random_government()

static struct government * pick_random_government | ( | struct player * | pplayer | ) |

inlinestatic

Helper for research_tech_lost().

Definition at line 783 of file techtools.c.

Referenced by research_tech_lost().

## ◆ pick_random_tech()

static Tech_type_id pick_random_tech | ( | const struct research * | presearch | ) |

static

Returns random researchable tech or A_FUTURE. No side effects.

Definition at line 917 of file techtools.c.

Referenced by choose_random_tech(), found_new_tech(), give_initial_techs(), and pick_free_tech().

## ◆ pick_random_tech_to_lose()

static Tech_type_id pick_random_tech_to_lose | ( | const struct research * | presearch | ) |

static

Choose a random tech for player to lose.

Definition at line 715 of file techtools.c.

Referenced by update_bulbs().

## ◆ research_apply_penalty()

void research_apply_penalty | ( | struct research * | presearch,
|  | Tech_type_id | tech,
|  | int | penalty_percent
| ) |  |

Apply a penalty to the research.

Definition at line 67 of file techtools.c.

Referenced by api_edit_give_technology(), do_tech_parasite_effect(), give_immediate_free_tech(), handle_diplomacy_accept_treaty_req(), and steal_a_tech().

## ◆ research_tech_lost()

static void research_tech_lost | ( | struct research * | presearch,
|  | Tech_type_id | tech
| ) |  |

static

Remove one tech from the research.

Definition at line 800 of file techtools.c.

Referenced by forget_tech_transferred(), and update_bulbs().

## ◆ script_tech_learned()

void script_tech_learned | ( | struct research * | presearch,
|  | struct player * | originating_plr,
|  | struct advance * | tech,
|  | const char * | reason
| ) |  |

Emit script signal(s) for player/team learning new tech. originating_plr is the player whose action caused this; may be NULL, and is only used to order the emission of the signals.

Definition at line 84 of file techtools.c.

Referenced by api_edit_give_technology(), handle_diplomacy_accept_treaty_req(), steal_a_tech(), and tech_researched().

## ◆ send_research_info()

void send_research_info | ( | const struct research * | presearch,
|  | const struct conn_list * | dest
| ) |  |

Send research info for 'presearch' to 'dest'. 'dest' can be NULL to send to all established connections.

Definition at line 273 of file techtools.c.

Referenced by api_edit_player_give_bulbs(), create_animals(), create_barbarian_player(), create_command_newcomer(), do_unit_establish_trade(), end_turn(), establish_embassy(), found_new_tech(), government_change(), handle_edit_player(), handle_edit_player_create(), handle_player_research(), handle_player_tech_goal(), research_tech_lost(), send_all_info(), and send_city_info().

## ◆ steal_a_tech()

Tech_type_id steal_a_tech | ( | struct player * | pplayer,
|  | struct player * | victim,
|  | Tech_type_id | preferred
| ) |  |

If victim has a tech which pplayer doesn't have, pplayer will get it. The clients will both be notified and the conquer cost penalty applied. Used for diplomats and city conquest. If preferred is A_UNSET one random tech will be chosen. Returns the stolen tech or A_NONE if no tech was found.

Definition at line 1207 of file techtools.c.

Referenced by diplomat_get_tech(), diplomat_incite(), unit_conquer_city(), and wipe_unit_full().

## ◆ tech_researched()

static void tech_researched | ( | struct research * | research | ) |

static

Players have researched a new technology.

Definition at line 107 of file techtools.c.

Referenced by choose_tech(), and update_bulbs().

## ◆ tech_transfer()

bool tech_transfer | ( | struct player * | plr_recv,
|  | struct player * | plr_donor,
|  | Tech_type_id | tech
| ) |  |

Check if the tech is lost by the donor or receiver. Returns if the receiver gets a new tech.

Definition at line 1410 of file techtools.c.

Referenced by handle_diplomacy_accept_treaty_req(), and steal_a_tech().

## ◆ update_bulbs()

void update_bulbs | ( | struct player * | pplayer,
|  | int | bulbs,
|  | bool | check_tech
| ) |  |

Adds the given number of bulbs into the player's tech and (if necessary and 'check_tech' is TRUE) completes the research. If the total number of bulbs is negative due to tech upkeep, one (randomly chosen) tech is lost.

The caller is responsible for sending updated player information.

This is called from each city every turn, from caravan revenue, at the end of the phase, and from lua API.

Definition at line 643 of file techtools.c.

Referenced by api_edit_player_give_bulbs(), do_unit_establish_trade(), end_phase(), srv_ready(), and update_city_activity().